/*
 * MainFrame.java
 *
 * Created on Mar 3, 2011, 4:57:17 PM
 */

package com.spam.mctool.view.main;

import java.util.ResourceBundle;
import javax.swing.JOptionPane;
import java.awt.Component;
import javax.swing.AbstractAction;
import java.awt.event.KeyEvent;
import javax.swing.KeyStroke;
import com.spam.mctool.controller.Profile;
import com.spam.mctool.intermediates.OverallReceiverStatisticsUpdatedEvent;
import com.spam.mctool.intermediates.OverallSenderStatisticsUpdatedEvent;
import com.spam.mctool.intermediates.ProfileChangeEvent;
import com.spam.mctool.intermediates.ReceiverAddedOrRemovedEvent;
import com.spam.mctool.intermediates.ReceiverDataChangedEvent;
import com.spam.mctool.intermediates.SenderAddedOrRemovedEvent;
import com.spam.mctool.intermediates.SenderDataChangedEvent;
import com.spam.mctool.model.MulticastStream;
import com.spam.mctool.model.Receiver;
import com.spam.mctool.model.ReceiverGroup;
import com.spam.mctool.model.ReceiverManager;
import com.spam.mctool.model.ReceiverPool;
import com.spam.mctool.model.Sender;
import com.spam.mctool.model.SenderManager;
import com.spam.mctool.view.GraphicalView;
import com.spam.mctool.view.dialogs.AboutDialog;
import com.spam.mctool.view.dialogs.EditReceiverDialog;
import com.spam.mctool.view.dialogs.EditSenderDialog;
import com.spam.mctool.view.dialogs.PreferencesDialog;
import com.spam.mctool.view.dialogs.SaveProfileDialog;
import com.spam.mctool.view.dialogs.Selection;
import com.spam.mctool.view.dialogs.ShowReceiverDialog;
import com.spam.mctool.view.dialogs.ShowSenderDialog;
import com.spam.mctool.view.main.receivertable.ReceiverTableModel;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.swing.Action;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.event.ListSelectionEvent;
import static javax.swing.JComponent.*;



/**
 * The main frame of the application. This class encapsulates all of the main frames
 * components and actions.
 *
 * Note that this class has been created with heavy use of the netbeans gui builder.
 *
 * @author Tobias Stöckel
 */
public class MainFrame extends javax.swing.JFrame implements javax.swing.event.ListSelectionListener {

    private static final long serialVersionUID = 1L;

    /**
     * backward reference to the view controller
     */
    private GraphicalView view;



    /**
     * Create and initialize the main frame. Parameterless constructor for
     * netbeans gui builder support. You shouldn't use this constructor
     * normally. You should use <code>MainFrame(GraphicalView view)</code> instead.
     */
    public MainFrame() {
        this(null);
    }



    /**
     * Creates and initializes the main frame with the specified view controller.
     * @param view
     */
    public MainFrame(GraphicalView view) {
        this.view = view;
        initComponents();
        initCustomComponents();
    }



    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        statusRenderer1 = new com.spam.mctool.view.main.sendertable.SenderStateRenderer();
        twoColorRenderer1 = new com.spam.mctool.view.main.TwoColorRenderer();
        senderPopupMenu = new javax.swing.JPopupMenu();
        miActivateSender = new javax.swing.JMenuItem();
        miDeactivateSender = new javax.swing.JMenuItem();
        miAddSender = new javax.swing.JMenuItem();
        miShowSender = new javax.swing.JMenuItem();
        miEditSender = new javax.swing.JMenuItem();
        miDeleteSender = new javax.swing.JMenuItem();
        receiverPopupMenu = new javax.swing.JPopupMenu();
        miActivateReceiver = new javax.swing.JMenuItem();
        miDeactivateReceiver = new javax.swing.JMenuItem();
        miAddReceiver = new javax.swing.JMenuItem();
        miShowReceiver = new javax.swing.JMenuItem();
        miEditReceiver = new javax.swing.JMenuItem();
        miDeleteReceiver = new javax.swing.JMenuItem();
        mainSplitPane = new javax.swing.JSplitPane();
        senderSplitPane = new javax.swing.JSplitPane();
        paSendingStatistics = new javax.swing.JPanel();
        laSendingStatistics = new javax.swing.JLabel();
        laSentCaption = new javax.swing.JLabel();
        laSenderRateCaption = new javax.swing.JLabel();
        sendingStatisticsSeparator = new javax.swing.JSeparator();
        laSent = new javax.swing.JLabel();
        laSenderRate = new javax.swing.JLabel();
        paSenderTableOuter = new javax.swing.JPanel();
        paSenderButtons = new javax.swing.JPanel();
        buActivateSender = new javax.swing.JButton();
        buDeactivateSender = new javax.swing.JButton();
        buAddSender = new javax.swing.JButton();
        buShowSender = new javax.swing.JButton();
        buEditSender = new javax.swing.JButton();
        buDeleteSender = new javax.swing.JButton();
        paSenderTableInner = new javax.swing.JPanel();
        senderTableScrollPane = new javax.swing.JScrollPane();
        senderTable = new com.spam.mctool.view.main.sendertable.JSenderTable();
        paSenderTableCaption = new javax.swing.JPanel();
        laSenderTableCaption = new javax.swing.JLabel();
        senderTableIcon = new javax.swing.JLabel();
        receiverSplitPane = new javax.swing.JSplitPane();
        paReceivingStatistics = new javax.swing.JPanel();
        laReceivingStatisticsCaption = new javax.swing.JLabel();
        laReceivedCaption = new javax.swing.JLabel();
        laReceivingRateCaption = new javax.swing.JLabel();
        laLostPacketsCaption = new javax.swing.JLabel();
        laFaultyPacketsCaption = new javax.swing.JLabel();
        receivingStatisticsSeparator = new javax.swing.JSeparator();
        laReceived = new javax.swing.JLabel();
        laReceivingRate = new javax.swing.JLabel();
        laLostPackets = new javax.swing.JLabel();
        laFaultyPackets = new javax.swing.JLabel();
        paReceiverTableOuter = new javax.swing.JPanel();
        paReceiverButtons = new javax.swing.JPanel();
        buActivateReceiver = new javax.swing.JButton();
        buDeactivateReceiver = new javax.swing.JButton();
        buAddReceiver = new javax.swing.JButton();
        buShowReceiver = new javax.swing.JButton();
        buEditReceiver = new javax.swing.JButton();
        buDeleteReceiver = new javax.swing.JButton();
        paReceiverTableInner = new javax.swing.JPanel();
        receiverTableScrollPane = new javax.swing.JScrollPane();
        receiverTable = new com.spam.mctool.view.main.receivertable.JReceiverTable();
        paReceiverTableCaption = new javax.swing.JPanel();
        laReceiverTableCaption = new javax.swing.JLabel();
        laReceiverTableIcon = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        menuFile = new javax.swing.JMenu();
        miOpenProfile = new javax.swing.JMenuItem();
        miSaveProfile = new javax.swing.JMenuItem();
        miSaveProfileAs = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        miPreferences = new javax.swing.JMenuItem();
        sepBeforeRecentProfiles = new javax.swing.JPopupMenu.Separator();
        sepAfterRecentProfiles = new javax.swing.JPopupMenu.Separator();
        miExit = new javax.swing.JMenuItem();
        menuHelp = new javax.swing.JMenu();
        miAbout = new javax.swing.JMenuItem();
        miHelp = new javax.swing.JMenuItem();

        statusRenderer1.setName("statusRenderer1"); // NOI18N

        twoColorRenderer1.setName("twoColorRenderer1"); // NOI18N

        senderPopupMenu.setName("senderPopupMenu"); // NOI18N

        miActivateSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/play_green.png")));
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("internationalization/Bundle"); // NOI18N
        miActivateSender.setText(bundle.getString("MainFrame.miActivateSender.text")); // NOI18N
        miActivateSender.setEnabled(false);
        miActivateSender.setName("miActivateSender"); // NOI18N
        miActivateSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miActivateSenderActionPerformed(evt);
            }
        });
        senderPopupMenu.add(miActivateSender);

        miDeactivateSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/stop_red.png")));
        miDeactivateSender.setText(bundle.getString("MainFrame.miDeactivateSender.text")); // NOI18N
        miDeactivateSender.setEnabled(false);
        miDeactivateSender.setName("miDeactivateSender"); // NOI18N
        miDeactivateSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miDeactivateSenderActionPerformed(evt);
            }
        });
        senderPopupMenu.add(miDeactivateSender);

        miAddSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/add_green.png")));
        miAddSender.setText(bundle.getString("MainFrame.miAddSender.text")); // NOI18N
        miAddSender.setName("miAddSender"); // NOI18N
        miAddSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miAddSenderActionPerformed(evt);
            }
        });
        senderPopupMenu.add(miAddSender);

        miShowSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/preview.png")));
        miShowSender.setText(bundle.getString("MainFrame.miShowSender.text")); // NOI18N
        miShowSender.setEnabled(false);
        miShowSender.setName("miShowSender"); // NOI18N
        miShowSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miShowSenderActionPerformed(evt);
            }
        });
        senderPopupMenu.add(miShowSender);

        miEditSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/edit.png")));
        miEditSender.setText(bundle.getString("MainFrame.miEditSender.text")); // NOI18N
        miEditSender.setEnabled(false);
        miEditSender.setName("miEditSender"); // NOI18N
        miEditSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miEditSenderActionPerformed(evt);
            }
        });
        senderPopupMenu.add(miEditSender);

        miDeleteSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/delete.png")));
        miDeleteSender.setText(bundle.getString("MainFrame.miDeleteSender.text")); // NOI18N
        miDeleteSender.setEnabled(false);
        miDeleteSender.setName("miDeleteSender"); // NOI18N
        miDeleteSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miDeleteSenderActionPerformed(evt);
            }
        });
        senderPopupMenu.add(miDeleteSender);

        receiverPopupMenu.setName("receiverPopupMenu"); // NOI18N

        miActivateReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/play_green.png")));
        miActivateReceiver.setText(bundle.getString("MainFrame.miActivateReceiver.text")); // NOI18N
        miActivateReceiver.setEnabled(false);
        miActivateReceiver.setName("miActivateReceiver"); // NOI18N
        miActivateReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miActivateReceiverActionPerformed(evt);
            }
        });
        receiverPopupMenu.add(miActivateReceiver);

        miDeactivateReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/stop_red.png")));
        miDeactivateReceiver.setText(bundle.getString("MainFrame.miDeactivateReceiver.text")); // NOI18N
        miDeactivateReceiver.setEnabled(false);
        miDeactivateReceiver.setName("miDeactivateReceiver"); // NOI18N
        miDeactivateReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miDeactivateReceiverActionPerformed(evt);
            }
        });
        receiverPopupMenu.add(miDeactivateReceiver);

        miAddReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/add_green.png")));
        miAddReceiver.setText(bundle.getString("MainFrame.miAddReceiver.text")); // NOI18N
        miAddReceiver.setName("miAddReceiver"); // NOI18N
        miAddReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miAddReceiverActionPerformed(evt);
            }
        });
        receiverPopupMenu.add(miAddReceiver);

        miShowReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/preview.png")));
        miShowReceiver.setText(bundle.getString("MainFrame.miShowReceiver.text")); // NOI18N
        miShowReceiver.setEnabled(false);
        miShowReceiver.setName("miShowReceiver"); // NOI18N
        miShowReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miShowReceiverActionPerformed(evt);
            }
        });
        receiverPopupMenu.add(miShowReceiver);

        miEditReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/edit.png")));
        miEditReceiver.setText(bundle.getString("MainFrame.miEditReceiver.text")); // NOI18N
        miEditReceiver.setEnabled(false);
        miEditReceiver.setName("miEditReceiver"); // NOI18N
        miEditReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miEditReceiverActionPerformed(evt);
            }
        });
        receiverPopupMenu.add(miEditReceiver);

        miDeleteReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/delete.png")));
        miDeleteReceiver.setText(bundle.getString("MainFrame.miDeleteReceiver.text")); // NOI18N
        miDeleteReceiver.setEnabled(false);
        miDeleteReceiver.setName("miDeleteReceiver"); // NOI18N
        miDeleteReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miDeleteReceiverActionPerformed(evt);
            }
        });
        receiverPopupMenu.add(miDeleteReceiver);

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle(java.util.ResourceBundle.getBundle("internationalization/Bundle").getString("MainFrame.title") + ((view.getCurrentProfile() != null && view.getCurrentProfile().getName() != null) ? " - " + view.getCurrentProfile().getName() : ""));
        setIconImage(new javax.swing.ImageIcon(getClass().getResource("/images/icon.png")).getImage());
        setName("Form"); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        mainSplitPane.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        mainSplitPane.setDividerLocation(267);
        mainSplitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        mainSplitPane.setResizeWeight(0.5);
        mainSplitPane.setContinuousLayout(true);
        mainSplitPane.setName("mainSplitPane"); // NOI18N
        mainSplitPane.setOneTouchExpandable(true);

        senderSplitPane.setBorder(null);
        senderSplitPane.setDividerLocation(580);
        senderSplitPane.setResizeWeight(1.0);
        senderSplitPane.setContinuousLayout(true);
        senderSplitPane.setName("senderSplitPane"); // NOI18N
        senderSplitPane.setOneTouchExpandable(true);

        paSendingStatistics.setName("paSendingStatistics"); // NOI18N

        laSendingStatistics.setText(bundle.getString("MainFrame.laSendingStatistics.text")); // NOI18N
        laSendingStatistics.setName("laSendingStatistics"); // NOI18N

        laSentCaption.setText(bundle.getString("MainFrame.laSentCaption.text")); // NOI18N
        laSentCaption.setName("laSentCaption"); // NOI18N

        laSenderRateCaption.setText(bundle.getString("MainFrame.laSenderRateCaption.text")); // NOI18N
        laSenderRateCaption.setName("laSenderRateCaption"); // NOI18N

        sendingStatisticsSeparator.setName("sendingStatisticsSeparator"); // NOI18N

        laSent.setText(bundle.getString("MainFrame.laSent.text")); // NOI18N
        laSent.setName("laSent"); // NOI18N

        laSenderRate.setText(bundle.getString("MainFrame.laSenderRate.text")); // NOI18N
        laSenderRate.setName("laSenderRate"); // NOI18N

        javax.swing.GroupLayout paSendingStatisticsLayout = new javax.swing.GroupLayout(paSendingStatistics);
        paSendingStatistics.setLayout(paSendingStatisticsLayout);
        paSendingStatisticsLayout.setHorizontalGroup(
            paSendingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(paSendingStatisticsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(paSendingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(sendingStatisticsSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                    .addComponent(laSendingStatistics)
                    .addGroup(paSendingStatisticsLayout.createSequentialGroup()
                        .addComponent(laSentCaption)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 76, Short.MAX_VALUE)
                        .addComponent(laSent))
                    .addGroup(paSendingStatisticsLayout.createSequentialGroup()
                        .addComponent(laSenderRateCaption)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 43, Short.MAX_VALUE)
                        .addComponent(laSenderRate)))
                .addContainerGap())
        );
        paSendingStatisticsLayout.setVerticalGroup(
            paSendingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(paSendingStatisticsLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(laSendingStatistics)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(sendingStatisticsSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(paSendingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(laSentCaption)
                    .addComponent(laSent))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(paSendingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(laSenderRateCaption)
                    .addComponent(laSenderRate))
                .addContainerGap(184, Short.MAX_VALUE))
        );

        senderSplitPane.setRightComponent(paSendingStatistics);

        paSenderTableOuter.setName("paSenderTableOuter"); // NOI18N
        paSenderTableOuter.setLayout(new java.awt.BorderLayout());

        paSenderButtons.setName("paSenderButtons"); // NOI18N
        paSenderButtons.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        buActivateSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/play_green.png"))); // NOI18N
        buActivateSender.setText(bundle.getString("MainFrame.buActivateSender.text")); // NOI18N
        buActivateSender.setToolTipText(bundle.getString("MainFrame.buActivateSender.toolTipText")); // NOI18N
        buActivateSender.setEnabled(false);
        buActivateSender.setName("buActivateSender"); // NOI18N
        buActivateSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buActivateSenderActionPerformed(evt);
            }
        });
        paSenderButtons.add(buActivateSender);

        buDeactivateSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/stop_red.png"))); // NOI18N
        buDeactivateSender.setText(bundle.getString("MainFrame.buDeactivateSender.text")); // NOI18N
        buDeactivateSender.setToolTipText(bundle.getString("MainFrame.buDeactivateSender.toolTipText")); // NOI18N
        buDeactivateSender.setEnabled(false);
        buDeactivateSender.setName("buDeactivateSender"); // NOI18N
        buDeactivateSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buDeactivateSenderActionPerformed(evt);
            }
        });
        paSenderButtons.add(buDeactivateSender);

        buAddSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/add_green.png"))); // NOI18N
        buAddSender.setText(bundle.getString("MainFrame.buAddSender.text")); // NOI18N
        buAddSender.setToolTipText(bundle.getString("MainFrame.buAddSender.toolTipText")); // NOI18N
        buAddSender.setName("buAddSender"); // NOI18N
        buAddSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buAddSenderActionPerformed(evt);
            }
        });
        paSenderButtons.add(buAddSender);

        buShowSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/preview.png"))); // NOI18N
        buShowSender.setText(bundle.getString("MainFrame.buShowSender.text")); // NOI18N
        buShowSender.setToolTipText(bundle.getString("MainFrame.buShowSender.toolTipText")); // NOI18N
        buShowSender.setEnabled(false);
        buShowSender.setName("buShowSender"); // NOI18N
        buShowSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buShowSenderActionPerformed(evt);
            }
        });
        paSenderButtons.add(buShowSender);

        buEditSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/edit.png"))); // NOI18N
        buEditSender.setText(bundle.getString("MainFrame.buEditSender.text")); // NOI18N
        buEditSender.setToolTipText(bundle.getString("MainFrame.buEditSender.toolTipText")); // NOI18N
        buEditSender.setEnabled(false);
        buEditSender.setName("buEditSender"); // NOI18N
        buEditSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buEditSenderActionPerformed(evt);
            }
        });
        paSenderButtons.add(buEditSender);

        buDeleteSender.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/delete.png"))); // NOI18N
        buDeleteSender.setText(bundle.getString("MainFrame.buDeleteSender.text")); // NOI18N
        buDeleteSender.setToolTipText(bundle.getString("MainFrame.buDeleteSender.toolTipText")); // NOI18N
        buDeleteSender.setEnabled(false);
        buDeleteSender.setName("buDeleteSender"); // NOI18N
        buDeleteSender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buDeleteSenderActionPerformed(evt);
            }
        });
        paSenderButtons.add(buDeleteSender);

        paSenderTableOuter.add(paSenderButtons, java.awt.BorderLayout.SOUTH);

        paSenderTableInner.setName("paSenderTableInner"); // NOI18N
        paSenderTableInner.setLayout(new java.awt.BorderLayout());

        senderTableScrollPane.setName("senderTableScrollPane"); // NOI18N
        senderTableScrollPane.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                senderTableScrollPaneMouseClicked(evt);
            }
        });

        senderTable.setComponentPopupMenu(senderPopupMenu);
        senderTable.setName("senderTable"); // NOI18N
        senderTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                senderTableMouseClicked(evt);
            }
        });
        senderTable.getSelectionModel().addListSelectionListener(this);
        senderTableScrollPane.setViewportView(senderTable);

        paSenderTableInner.add(senderTableScrollPane, java.awt.BorderLayout.CENTER);

        paSenderTableOuter.add(paSenderTableInner, java.awt.BorderLayout.CENTER);

        paSenderTableCaption.setName("paSenderTableCaption"); // NOI18N
        paSenderTableCaption.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        laSenderTableCaption.setText(bundle.getString("MainFrame.laSenderTableCaption.text")); // NOI18N
        laSenderTableCaption.setName("laSenderTableCaption"); // NOI18N
        paSenderTableCaption.add(laSenderTableCaption);

        senderTableIcon.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/sender.png"))); // NOI18N
        senderTableIcon.setName("senderTableIcon"); // NOI18N
        paSenderTableCaption.add(senderTableIcon);

        paSenderTableOuter.add(paSenderTableCaption, java.awt.BorderLayout.NORTH);

        senderSplitPane.setLeftComponent(paSenderTableOuter);

        mainSplitPane.setTopComponent(senderSplitPane);

        receiverSplitPane.setBorder(null);
        receiverSplitPane.setDividerLocation(580);
        receiverSplitPane.setResizeWeight(1.0);
        receiverSplitPane.setContinuousLayout(true);
        receiverSplitPane.setName("receiverSplitPane"); // NOI18N
        receiverSplitPane.setOneTouchExpandable(true);

        paReceivingStatistics.setName("paReceivingStatistics"); // NOI18N

        laReceivingStatisticsCaption.setText(bundle.getString("MainFrame.laReceivingStatisticsCaption.text")); // NOI18N
        laReceivingStatisticsCaption.setName("laReceivingStatisticsCaption"); // NOI18N

        laReceivedCaption.setText(bundle.getString("MainFrame.laReceivedCaption.text")); // NOI18N
        laReceivedCaption.setName("laReceivedCaption"); // NOI18N

        laReceivingRateCaption.setText(bundle.getString("MainFrame.laReceivingRateCaption.text")); // NOI18N
        laReceivingRateCaption.setName("laReceivingRateCaption"); // NOI18N

        laLostPacketsCaption.setText(bundle.getString("MainFrame.laLostPacketsCaption.text")); // NOI18N
        laLostPacketsCaption.setName("laLostPacketsCaption"); // NOI18N

        laFaultyPacketsCaption.setText(bundle.getString("MainFrame.laFaultyPacketsCaption.text")); // NOI18N
        laFaultyPacketsCaption.setName("laFaultyPacketsCaption"); // NOI18N

        receivingStatisticsSeparator.setName("receivingStatisticsSeparator"); // NOI18N

        laReceived.setText(bundle.getString("MainFrame.laReceived.text")); // NOI18N
        laReceived.setName("laReceived"); // NOI18N

        laReceivingRate.setText(bundle.getString("MainFrame.laReceivingRate.text")); // NOI18N
        laReceivingRate.setName("laReceivingRate"); // NOI18N

        laLostPackets.setText(bundle.getString("MainFrame.laLostPackets.text")); // NOI18N
        laLostPackets.setName("laLostPackets"); // NOI18N

        laFaultyPackets.setText(bundle.getString("MainFrame.laFaultyPackets.text")); // NOI18N
        laFaultyPackets.setName("laFaultyPackets"); // NOI18N

        javax.swing.GroupLayout paReceivingStatisticsLayout = new javax.swing.GroupLayout(paReceivingStatistics);
        paReceivingStatistics.setLayout(paReceivingStatisticsLayout);
        paReceivingStatisticsLayout.setHorizontalGroup(
            paReceivingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(paReceivingStatisticsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(paReceivingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(laReceivingStatisticsCaption)
                    .addComponent(receivingStatisticsSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                    .addGroup(paReceivingStatisticsLayout.createSequentialGroup()
                        .addComponent(laReceivedCaption)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 54, Short.MAX_VALUE)
                        .addComponent(laReceived))
                    .addGroup(paReceivingStatisticsLayout.createSequentialGroup()
                        .addComponent(laReceivingRateCaption)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 43, Short.MAX_VALUE)
                        .addComponent(laReceivingRate))
                    .addGroup(paReceivingStatisticsLayout.createSequentialGroup()
                        .addComponent(laLostPacketsCaption)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 78, Short.MAX_VALUE)
                        .addComponent(laLostPackets))
                    .addGroup(paReceivingStatisticsLayout.createSequentialGroup()
                        .addComponent(laFaultyPacketsCaption)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 68, Short.MAX_VALUE)
                        .addComponent(laFaultyPackets)))
                .addContainerGap())
        );
        paReceivingStatisticsLayout.setVerticalGroup(
            paReceivingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(paReceivingStatisticsLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(laReceivingStatisticsCaption)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(receivingStatisticsSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(paReceivingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(laReceivedCaption)
                    .addComponent(laReceived))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(paReceivingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(laReceivingRateCaption)
                    .addComponent(laReceivingRate))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(paReceivingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(laLostPacketsCaption)
                    .addComponent(laLostPackets))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(paReceivingStatisticsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(laFaultyPacketsCaption)
                    .addComponent(laFaultyPackets))
                .addContainerGap(143, Short.MAX_VALUE))
        );

        receiverSplitPane.setRightComponent(paReceivingStatistics);

        paReceiverTableOuter.setName("paReceiverTableOuter"); // NOI18N
        paReceiverTableOuter.setLayout(new java.awt.BorderLayout());

        paReceiverButtons.setName("paReceiverButtons"); // NOI18N
        paReceiverButtons.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        buActivateReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/play_green.png"))); // NOI18N
        buActivateReceiver.setText(bundle.getString("MainFrame.buActivateReceiver.text")); // NOI18N
        buActivateReceiver.setToolTipText(bundle.getString("MainFrame.buActivateReceiver.toolTipText")); // NOI18N
        buActivateReceiver.setEnabled(false);
        buActivateReceiver.setName("buActivateReceiver"); // NOI18N
        buActivateReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buActivateReceiverActionPerformed(evt);
            }
        });
        paReceiverButtons.add(buActivateReceiver);

        buDeactivateReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/stop_red.png"))); // NOI18N
        buDeactivateReceiver.setText(bundle.getString("MainFrame.buDeactivateReceiver.text")); // NOI18N
        buDeactivateReceiver.setToolTipText(bundle.getString("MainFrame.buDeactivateReceiver.toolTipText")); // NOI18N
        buDeactivateReceiver.setEnabled(false);
        buDeactivateReceiver.setName("buDeactivateReceiver"); // NOI18N
        buDeactivateReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buDeactivateReceiverActionPerformed(evt);
            }
        });
        paReceiverButtons.add(buDeactivateReceiver);

        buAddReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/add_green.png"))); // NOI18N
        buAddReceiver.setText(bundle.getString("MainFrame.buAddReceiver.text")); // NOI18N
        buAddReceiver.setToolTipText(bundle.getString("MainFrame.buAddReceiver.toolTipText")); // NOI18N
        buAddReceiver.setName("buAddReceiver"); // NOI18N
        buAddReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buAddReceiverActionPerformed(evt);
            }
        });
        paReceiverButtons.add(buAddReceiver);

        buShowReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/preview.png"))); // NOI18N
        buShowReceiver.setText(bundle.getString("MainFrame.buShowReceiver.text")); // NOI18N
        buShowReceiver.setToolTipText(bundle.getString("MainFrame.buShowReceiver.toolTipText")); // NOI18N
        buShowReceiver.setEnabled(false);
        buShowReceiver.setName("buShowReceiver"); // NOI18N
        buShowReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buShowReceiverActionPerformed(evt);
            }
        });
        paReceiverButtons.add(buShowReceiver);

        buEditReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/edit.png"))); // NOI18N
        buEditReceiver.setText(bundle.getString("MainFrame.buEditReceiver.text")); // NOI18N
        buEditReceiver.setToolTipText(bundle.getString("MainFrame.buEditReceiver.toolTipText")); // NOI18N
        buEditReceiver.setEnabled(false);
        buEditReceiver.setName("buEditReceiver"); // NOI18N
        buEditReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buEditReceiverActionPerformed(evt);
            }
        });
        paReceiverButtons.add(buEditReceiver);

        buDeleteReceiver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/delete.png"))); // NOI18N
        buDeleteReceiver.setText(bundle.getString("MainFrame.buDeleteReceiver.text")); // NOI18N
        buDeleteReceiver.setToolTipText(bundle.getString("MainFrame.buDeleteReceiver.toolTipText")); // NOI18N
        buDeleteReceiver.setEnabled(false);
        buDeleteReceiver.setName("buDeleteReceiver"); // NOI18N
        buDeleteReceiver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buDeleteReceiverActionPerformed(evt);
            }
        });
        paReceiverButtons.add(buDeleteReceiver);

        paReceiverTableOuter.add(paReceiverButtons, java.awt.BorderLayout.PAGE_END);

        paReceiverTableInner.setName("paReceiverTableInner"); // NOI18N
        paReceiverTableInner.setLayout(new java.awt.BorderLayout());

        receiverTableScrollPane.setName("receiverTableScrollPane"); // NOI18N
        receiverTableScrollPane.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                receiverTableScrollPaneMouseClicked(evt);
            }
        });

        receiverTable.setComponentPopupMenu(receiverPopupMenu);
        receiverTable.setGridColor(javax.swing.UIManager.getDefaults().getColor("control"));
        receiverTable.setIntercellSpacing(new java.awt.Dimension(0, 1));
        receiverTable.setName("receiverTable"); // NOI18N
        receiverTable.getSelectionModel().addListSelectionListener(this);
        receiverTableScrollPane.setViewportView(receiverTable);

        paReceiverTableInner.add(receiverTableScrollPane, java.awt.BorderLayout.CENTER);

        paReceiverTableOuter.add(paReceiverTableInner, java.awt.BorderLayout.CENTER);

        paReceiverTableCaption.setName("paReceiverTableCaption"); // NOI18N
        paReceiverTableCaption.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        laReceiverTableCaption.setText(bundle.getString("MainFrame.laReceiverTableCaption.text")); // NOI18N
        laReceiverTableCaption.setName("laReceiverTableCaption"); // NOI18N
        paReceiverTableCaption.add(laReceiverTableCaption);

        laReceiverTableIcon.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/receiver.png"))); // NOI18N
        laReceiverTableIcon.setName("laReceiverTableIcon"); // NOI18N
        paReceiverTableCaption.add(laReceiverTableIcon);

        paReceiverTableOuter.add(paReceiverTableCaption, java.awt.BorderLayout.NORTH);

        receiverSplitPane.setLeftComponent(paReceiverTableOuter);

        mainSplitPane.setRightComponent(receiverSplitPane);

        menuBar.setName("menuBar"); // NOI18N

        menuFile.setText(bundle.getString("MainFrame.menuFile.text")); // NOI18N
        menuFile.setName("menuFile"); // NOI18N
        menuFile.addMenuListener(new javax.swing.event.MenuListener() {
            public void menuCanceled(javax.swing.event.MenuEvent evt) {
            }
            public void menuDeselected(javax.swing.event.MenuEvent evt) {
            }
            public void menuSelected(javax.swing.event.MenuEvent evt) {
                menuFileMenuSelected(evt);
            }
        });

        miOpenProfile.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        miOpenProfile.setText(bundle.getString("MainFrame.miOpenProfile.text_1")); // NOI18N
        miOpenProfile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miOpenProfileActionPerformed(evt);
            }
        });
        menuFile.add(miOpenProfile);

        miSaveProfile.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        miSaveProfile.setText(bundle.getString("MainFrame.miSaveProfile.text")); // NOI18N
        miSaveProfile.setEnabled(false);
        miSaveProfile.setName("miSaveProfile"); // NOI18N
        miSaveProfile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miSaveProfileActionPerformed(evt);
            }
        });
        menuFile.add(miSaveProfile);

        miSaveProfileAs.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        miSaveProfileAs.setText(bundle.getString("MainFrame.miSaveProfileAs.text")); // NOI18N
        miSaveProfileAs.setName("miSaveProfileAs"); // NOI18N
        miSaveProfileAs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miSaveProfileAsActionPerformed(evt);
            }
        });
        menuFile.add(miSaveProfileAs);

        jSeparator1.setName("jSeparator1"); // NOI18N
        menuFile.add(jSeparator1);

        miPreferences.setText(bundle.getString("MainFrame.miPreferences.text_2")); // NOI18N
        miPreferences.setName("miPreferences"); // NOI18N
        miPreferences.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miPreferencesActionPerformed(evt);
            }
        });
        menuFile.add(miPreferences);

        sepBeforeRecentProfiles.setName("sepBeforeRecentProfiles"); // NOI18N
        menuFile.add(sepBeforeRecentProfiles);

        sepAfterRecentProfiles.setName("sepAfterRecentProfiles"); // NOI18N
        menuFile.add(sepAfterRecentProfiles);

        miExit.setText(bundle.getString("MainFrame.miExit.text_1")); // NOI18N
        miExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miExitActionPerformed(evt);
            }
        });
        menuFile.add(miExit);

        menuBar.add(menuFile);

        menuHelp.setText(bundle.getString("MainFrame.menuHelp.text")); // NOI18N
        menuHelp.setName("menuHelp"); // NOI18N

        miAbout.setText(bundle.getString("MainFrame.miAbout.text")); // NOI18N
        miAbout.setName("miAbout"); // NOI18N
        miAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miAboutActionPerformed(evt);
            }
        });
        menuHelp.add(miAbout);

        miHelp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        miHelp.setText(bundle.getString("MainFrame.miHelp.text")); // NOI18N
        miHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miHelpActionPerformed(evt);
            }
        });
        menuHelp.add(miHelp);

        menuBar.add(menuHelp);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(mainSplitPane, javax.swing.GroupLayout.DEFAULT_SIZE, 753, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(mainSplitPane, javax.swing.GroupLayout.DEFAULT_SIZE, 538, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void buActivateSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buActivateSenderActionPerformed
        for(Sender s : senderTable.getSelectedSenders()) {
            s.activate();
        }
        refreshSenderControls();
        senderTable.repaint();
    }//GEN-LAST:event_buActivateSenderActionPerformed

    /**
     * assumption: there is only one row selected! This should be assured by
     * enabling/disabling controls beforehand.
     * @param evt
     */
    private void buShowSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buShowSenderActionPerformed
        Sender s = senderTable.getSelectedSenders().get(0);
        ShowSenderDialog dlg = new ShowSenderDialog(this, false, s);
        s.addSenderDataChangeListener(dlg);
        dlg.setVisible(true);
    }//GEN-LAST:event_buShowSenderActionPerformed

    private void buAddSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buAddSenderActionPerformed
        if(senderTable.getSelectedRowCount() > 0) {
            Sender s = senderTable.getSelectedSenders().get(0);
            new EditSenderDialog(this, true, s, true).setVisible(true);
        } else {
            new EditSenderDialog(this, true).setVisible(true);
        }
    }//GEN-LAST:event_buAddSenderActionPerformed

    private void buDeactivateSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buDeactivateSenderActionPerformed
        for(Sender s : senderTable.getSelectedSenders()) {
            s.deactivate();
        }
        refreshSenderControls();
        senderTable.repaint();
    }//GEN-LAST:event_buDeactivateSenderActionPerformed

    private void buAddReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buAddReceiverActionPerformed
        List<ReceiverGroup> selectedGroups = receiverTable.getSelectedReceiverGroups();
        if(selectedGroups.size() > 0) {
            ReceiverGroup rg = selectedGroups.get(0);
            new EditReceiverDialog(this, true, rg, true).setVisible(true);
        } else {
            new EditReceiverDialog(this, true).setVisible(true);
        }
    }//GEN-LAST:event_buAddReceiverActionPerformed

    private void senderTableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_senderTableMouseClicked
        if(evt.getButton() == MouseEvent.BUTTON1 && evt.getClickCount() == 2) {
            if(senderTable.getSelectedSenders().size() == 1) {
                Sender sender = senderTable.getSelectedSenders().get(0);
                new EditSenderDialog(this, true, sender, false).setVisible(true);
            }
        }
    }//GEN-LAST:event_senderTableMouseClicked

    /**
     * assumption: there is only one sender selected!
     * @param evt
     */
    private void buEditSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buEditSenderActionPerformed
        Sender s = senderTable.getSelectedSenders().get(0);
        new EditSenderDialog(this, true, s, false).setVisible(true);
        refreshSenderControls();
    }//GEN-LAST:event_buEditSenderActionPerformed

    private void buDeleteSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buDeleteSenderActionPerformed
        Set<MulticastStream> senders = new HashSet<MulticastStream>(senderTable.getSelectedSenders());
        this.view.removeStreams(senders);
    }//GEN-LAST:event_buDeleteSenderActionPerformed

    /**
     * assumption: there is at least one receivergroup selected!
     * @param evt
     */
    private void buActivateReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buActivateReceiverActionPerformed
        for(ReceiverGroup r : receiverTable.getSelectedReceiverGroups()) {
            r.activate();
        }
        refreshReceiverControls();
        receiverTable.repaint();
    }//GEN-LAST:event_buActivateReceiverActionPerformed

    /**
     * assumption: there is at least one receivergroup selected!
     * @param evt
     */
    private void buDeactivateReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buDeactivateReceiverActionPerformed
        for(ReceiverGroup r : receiverTable.getSelectedReceiverGroups()) {
            r.deactivate();
        }
        refreshReceiverControls();
        receiverTable.repaint();
    }//GEN-LAST:event_buDeactivateReceiverActionPerformed

    /**
     * assumption: there is only one receiver selected.
     * @param evt
     */
    private void buShowReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buShowReceiverActionPerformed
        Receiver r = receiverTable.getSelectedReceivers().get(0);
        ReceiverGroup rg = receiverTable.getParent(r);
        ShowReceiverDialog dlg = new ShowReceiverDialog(this, false, r, rg);
        rg.addReceiverDataChangeListener(dlg);
        dlg.setVisible(true);
    }//GEN-LAST:event_buShowReceiverActionPerformed

    /**
     * assumption: there are only rows selected to be associated with exactly
     * one receivergroup
     * @param evt
     */
    private void buEditReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buEditReceiverActionPerformed
        ReceiverGroup rg = receiverTable.getSelectedReceiverGroups().get(0);
        new EditReceiverDialog(this, true, rg, false).setVisible(true);
        refreshReceiverControls();
    }//GEN-LAST:event_buEditReceiverActionPerformed

    private void buDeleteReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buDeleteReceiverActionPerformed
        Set<MulticastStream> groups = new HashSet<MulticastStream>(receiverTable.getSelectedReceiverGroups());
        Set<Receiver> receivers   = new HashSet<Receiver>(receiverTable.getSelectedReceivers());
        for(Receiver r : receivers) {
            ReceiverGroup parent = receiverTable.getParent(r);
            parent.removeReceiver(r);
            receiverTable.receiverRemoved(r);
        }
        view.removeStreams(groups);
    }//GEN-LAST:event_buDeleteReceiverActionPerformed

    private void senderTableScrollPaneMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_senderTableScrollPaneMouseClicked
        senderTable.clearSelection();
    }//GEN-LAST:event_senderTableScrollPaneMouseClicked

    private void receiverTableScrollPaneMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_receiverTableScrollPaneMouseClicked
        receiverTable.clearSelection();
    }//GEN-LAST:event_receiverTableScrollPaneMouseClicked

    private void miOpenProfileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miOpenProfileActionPerformed
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            view.loadProfile(chooser.getSelectedFile());
        }
        if(view.getCurrentProfile() != null) {
            miSaveProfile.setEnabled(true);
        } else {
            miSaveProfile.setEnabled(false);
        }
    }//GEN-LAST:event_miOpenProfileActionPerformed

    private void miSaveProfileAsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miSaveProfileAsActionPerformed
        Profile currentProfile = view.getCurrentProfile();
        SaveProfileDialog dlg = new SaveProfileDialog(this, true, currentProfile);
        dlg.setVisible(true);
        if(dlg.getSelection().equals(JFileChooser.APPROVE_SELECTION)) {
            try {
                view.saveProfile(dlg.getProfileName(), dlg.getSelectedFile());
            } catch (NullPointerException ex) {
                // jo, kann man nix machen
            }
        }
        loadRecentProfiles();
        if(view.getCurrentProfile() != null) {
            miSaveProfile.setEnabled(true);
        } else {
            miSaveProfile.setEnabled(false);
        }
    }//GEN-LAST:event_miSaveProfileAsActionPerformed

    private void miSaveProfileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miSaveProfileActionPerformed
        view.saveCurrentProfile();
        if(view.getCurrentProfile() != null) {
            miSaveProfile.setEnabled(true);
        } else {
            miSaveProfile.setEnabled(false);
        }
    }//GEN-LAST:event_miSaveProfileActionPerformed

    private void miExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miExitActionPerformed
        view.exitApplication();
    }//GEN-LAST:event_miExitActionPerformed

    private void miAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miAboutActionPerformed
        new AboutDialog(this, true).setVisible(true);
    }//GEN-LAST:event_miAboutActionPerformed

    private void miPreferencesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miPreferencesActionPerformed
        PreferencesDialog dlg = new PreferencesDialog(this, true);
        dlg.setVisible(true);
        if(dlg.getSelection().equals(Selection.APPROVE_SELECTION)) {
            view.setPreferences(dlg);
        }
    }//GEN-LAST:event_miPreferencesActionPerformed

    private void menuFileMenuSelected(javax.swing.event.MenuEvent evt) {//GEN-FIRST:event_menuFileMenuSelected
        loadRecentProfiles();
    }//GEN-LAST:event_menuFileMenuSelected

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        view.exitApplication();
    }//GEN-LAST:event_formWindowClosing

    private void miActivateSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miActivateSenderActionPerformed
        buActivateSenderActionPerformed(evt);
    }//GEN-LAST:event_miActivateSenderActionPerformed

    private void miDeactivateSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miDeactivateSenderActionPerformed
        buDeactivateSenderActionPerformed(evt);
    }//GEN-LAST:event_miDeactivateSenderActionPerformed

    private void miAddSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miAddSenderActionPerformed
        buAddSenderActionPerformed(evt);
    }//GEN-LAST:event_miAddSenderActionPerformed

    private void miShowSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miShowSenderActionPerformed
        buShowSenderActionPerformed(evt);
    }//GEN-LAST:event_miShowSenderActionPerformed

    private void miEditSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miEditSenderActionPerformed
        buEditSenderActionPerformed(evt);
    }//GEN-LAST:event_miEditSenderActionPerformed

    private void miDeleteSenderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miDeleteSenderActionPerformed
        buDeleteSenderActionPerformed(evt);
    }//GEN-LAST:event_miDeleteSenderActionPerformed

    private void miActivateReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miActivateReceiverActionPerformed
        buActivateReceiverActionPerformed(evt);
    }//GEN-LAST:event_miActivateReceiverActionPerformed

    private void miDeactivateReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miDeactivateReceiverActionPerformed
        buDeactivateReceiverActionPerformed(evt);
    }//GEN-LAST:event_miDeactivateReceiverActionPerformed

    private void miAddReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miAddReceiverActionPerformed
        buAddReceiverActionPerformed(evt);
    }//GEN-LAST:event_miAddReceiverActionPerformed

    private void miShowReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miShowReceiverActionPerformed
        buShowReceiverActionPerformed(evt);
    }//GEN-LAST:event_miShowReceiverActionPerformed

    private void miEditReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miEditReceiverActionPerformed
        buEditReceiverActionPerformed(evt);
    }//GEN-LAST:event_miEditReceiverActionPerformed

    private void miDeleteReceiverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miDeleteReceiverActionPerformed
        buDeleteReceiverActionPerformed(evt);
    }//GEN-LAST:event_miDeleteReceiverActionPerformed

    private void miHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miHelpActionPerformed
        ResourceBundle bundle = ResourceBundle.getBundle("internationalization/Bundle");

        Component parent      = this;
        String    message     = bundle.getString("MainFrame.help.message");
        String    title       = bundle.getString("MainFrame.help.title");
        int       messageType = JOptionPane.PLAIN_MESSAGE;

        JOptionPane.showMessageDialog(parent, message, title, messageType);
    }//GEN-LAST:event_miHelpActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                MainFrame frame = new MainFrame();
                frame.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buActivateReceiver;
    private javax.swing.JButton buActivateSender;
    private javax.swing.JButton buAddReceiver;
    private javax.swing.JButton buAddSender;
    private javax.swing.JButton buDeactivateReceiver;
    private javax.swing.JButton buDeactivateSender;
    private javax.swing.JButton buDeleteReceiver;
    private javax.swing.JButton buDeleteSender;
    private javax.swing.JButton buEditReceiver;
    private javax.swing.JButton buEditSender;
    private javax.swing.JButton buShowReceiver;
    private javax.swing.JButton buShowSender;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JLabel laFaultyPackets;
    private javax.swing.JLabel laFaultyPacketsCaption;
    private javax.swing.JLabel laLostPackets;
    private javax.swing.JLabel laLostPacketsCaption;
    private javax.swing.JLabel laReceived;
    private javax.swing.JLabel laReceivedCaption;
    private javax.swing.JLabel laReceiverTableCaption;
    private javax.swing.JLabel laReceiverTableIcon;
    private javax.swing.JLabel laReceivingRate;
    private javax.swing.JLabel laReceivingRateCaption;
    private javax.swing.JLabel laReceivingStatisticsCaption;
    private javax.swing.JLabel laSenderRate;
    private javax.swing.JLabel laSenderRateCaption;
    private javax.swing.JLabel laSenderTableCaption;
    private javax.swing.JLabel laSendingStatistics;
    private javax.swing.JLabel laSent;
    private javax.swing.JLabel laSentCaption;
    private javax.swing.JSplitPane mainSplitPane;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenu menuFile;
    private javax.swing.JMenu menuHelp;
    private javax.swing.JMenuItem miAbout;
    private javax.swing.JMenuItem miActivateReceiver;
    private javax.swing.JMenuItem miActivateSender;
    private javax.swing.JMenuItem miAddReceiver;
    private javax.swing.JMenuItem miAddSender;
    private javax.swing.JMenuItem miDeactivateReceiver;
    private javax.swing.JMenuItem miDeactivateSender;
    private javax.swing.JMenuItem miDeleteReceiver;
    private javax.swing.JMenuItem miDeleteSender;
    private javax.swing.JMenuItem miEditReceiver;
    private javax.swing.JMenuItem miEditSender;
    private javax.swing.JMenuItem miExit;
    private javax.swing.JMenuItem miHelp;
    private javax.swing.JMenuItem miOpenProfile;
    private javax.swing.JMenuItem miPreferences;
    private javax.swing.JMenuItem miSaveProfile;
    private javax.swing.JMenuItem miSaveProfileAs;
    private javax.swing.JMenuItem miShowReceiver;
    private javax.swing.JMenuItem miShowSender;
    private javax.swing.JPanel paReceiverButtons;
    private javax.swing.JPanel paReceiverTableCaption;
    private javax.swing.JPanel paReceiverTableInner;
    private javax.swing.JPanel paReceiverTableOuter;
    private javax.swing.JPanel paReceivingStatistics;
    private javax.swing.JPanel paSenderButtons;
    private javax.swing.JPanel paSenderTableCaption;
    private javax.swing.JPanel paSenderTableInner;
    private javax.swing.JPanel paSenderTableOuter;
    private javax.swing.JPanel paSendingStatistics;
    private javax.swing.JPopupMenu receiverPopupMenu;
    private javax.swing.JSplitPane receiverSplitPane;
    private com.spam.mctool.view.main.receivertable.JReceiverTable receiverTable;
    private javax.swing.JScrollPane receiverTableScrollPane;
    private javax.swing.JSeparator receivingStatisticsSeparator;
    private javax.swing.JPopupMenu senderPopupMenu;
    private javax.swing.JSplitPane senderSplitPane;
    private com.spam.mctool.view.main.sendertable.JSenderTable senderTable;
    private javax.swing.JLabel senderTableIcon;
    private javax.swing.JScrollPane senderTableScrollPane;
    private javax.swing.JSeparator sendingStatisticsSeparator;
    private javax.swing.JPopupMenu.Separator sepAfterRecentProfiles;
    private javax.swing.JPopupMenu.Separator sepBeforeRecentProfiles;
    private com.spam.mctool.view.main.sendertable.SenderStateRenderer statusRenderer1;
    private com.spam.mctool.view.main.TwoColorRenderer twoColorRenderer1;
    // End of variables declaration//GEN-END:variables



    /**
     * the file chooser used for opening profiles
     */
    private JFileChooser chooser;

    /**
     * action for deleting senders via del key
     */
    Action  deleteSenderAction;

    /**
     * action for deleting receivers via del key
     */
    Action  deleteReceiverAction;



    /**
     * Tells the GUI controller to create a new sender and optionally activate it
     * afterwards. Provides feedback, whether the operation was successful or not.
     * More information about why the creation has failed will be communicated
     * via ErrorEvents.
     * @param senderMap Map containing parameters for the sender to be created.
     * The map's contents are specified in SenderManager.
     * @param activate Shall the sender be activated after creation?
     * @return True, if the sender was created successfully. False, if the Sender
     * could not be created.
     */
    public boolean addSender(Map<String, String> senderMap, boolean activate) {
        return this.view.addSender(senderMap, activate);
    }



    /**
     * Forwards a sender addition event to the sender table.
     */
    public void senderAdded(SenderAddedOrRemovedEvent e) {
        senderTable.senderAdded(e);
    }



    /**
     * Forwards a sender removal event to the sender table.
     */
    public void senderRemoved(SenderAddedOrRemovedEvent e) {
        senderTable.senderRemoved(e);
    }



    /**
     * Forwards a change in sender data to the sender table.
     */
    public void dataChanged(SenderDataChangedEvent e) {

        // update the sender table
        senderTable.dataChanged(e);
    }



    /**
     * Forwards a receiver addition event to the receiver table.
     */
    public void receiverGroupAdded(ReceiverAddedOrRemovedEvent e) {
        receiverTable.receiverGroupAdded(e);
    }



    /**
     * Forwards a receiver removal event to the receiver table.
     * @param e
     */
    public void receiverGroupRemoved(ReceiverAddedOrRemovedEvent e) {
        receiverTable.receiverGroupRemoved(e);
    }



    /**
     * Forwards a change in receiver data to the receiver table
     */
    public void dataChanged(ReceiverDataChangedEvent e) {

        // update the receiver table
        receiverTable.dataChanged(e);
    }



    /**
     * Tells the GUI controller to add a receiver group to this view's
     * controller and optionally activate it
     * afterwards. Provides feedback, whether the operation was successful or not.
     * More information about why the creation has failed will be communicated
     * via ErrorEvents.
     * @param receiverMap Map containing parameters for the receiver group to be created.
     * The map's contents are specified in ReceiverManager.
     * @param activate Shall the receiver group be activated after creation?
     * @return True, if the receiver group was created successfully. False, if
     * rhe receiver group could not be created.
     */
    public boolean addReceiverGroup(Map<String, String> receiverMap, boolean activate) {
        return this.view.addReceiverGroup(receiverMap, activate);
    }



    /**
     * This method is called by the tables if their selection changes eg. because
     * of user interaction. It makes sure that the correct buttons and menu
     * items are enabled for that selection. Also makes sure that there are only
     * rows in one of the table selected.
     * @param e
     */
    public void valueChanged(ListSelectionEvent e) {
        if(e.getSource() == senderTable.getSelectionModel()) {
            refreshSenderControls();
            if(senderTable.getSelectedRowCount() > 0 && receiverTable.getSelectedRowCount() > 0) {
                receiverTable.clearSelection();
            }
        } else if (e.getSource() == receiverTable.getSelectionModel()) {
            refreshReceiverControls();
            if(receiverTable.getSelectedRowCount() > 0 && senderTable.getSelectedRowCount() > 0) {
                senderTable.clearSelection();
            }
        }
    }



    /**
     * refresh all the buttons and menu items related to sender modification. State
     * is determined by the current selection in the sender table.
     */
    private void refreshSenderControls() {
        int rc = senderTable.getSelectedRowCount();
        if(rc == 0) {
            buActivateSender.setEnabled(false);
            buDeactivateSender.setEnabled(false);
            buShowSender.setEnabled(false);
            buEditSender.setEnabled(false);
            buDeleteSender.setEnabled(false);

            miActivateSender.setEnabled(false);
            miDeactivateSender.setEnabled(false);
            miShowSender.setEnabled(false);
            miEditSender.setEnabled(false);
            miDeleteSender.setEnabled(false);
        } else if (rc == 1) {
            buShowSender.setEnabled(true);
            buEditSender.setEnabled(true);
            buDeleteSender.setEnabled(true);
            miShowSender.setEnabled(true);
            miEditSender.setEnabled(true);
            miDeleteSender.setEnabled(true);
            if(senderTable.getSelectedSenders().get(0).isActive()) {
                buActivateSender.setEnabled(false);
                buDeactivateSender.setEnabled(true);
                miActivateSender.setEnabled(false);
                miDeactivateSender.setEnabled(true);
            } else {
                buActivateSender.setEnabled(true);
                buDeactivateSender.setEnabled(false);
                miActivateSender.setEnabled(true);
                miDeactivateSender.setEnabled(false);
            }
        } else if (rc > 1) {
            buActivateSender.setEnabled(true);
            buDeactivateSender.setEnabled(true);
            buShowSender.setEnabled(false);
            buEditSender.setEnabled(false);
            buDeleteSender.setEnabled(true);

            miActivateSender.setEnabled(true);
            miDeactivateSender.setEnabled(true);
            miShowSender.setEnabled(false);
            miEditSender.setEnabled(false);
            miDeleteSender.setEnabled(true);
        }
    }



    /**
     * refresh all the buttons and menu items related to receiver modification. State
     * is determined by the current selection in the receiver table.
     */
    private void refreshReceiverControls() {
        int rowCount = receiverTable.getSelectedRowCount();

        if(rowCount > 0) {
            // Activate/Deactivate Buttons
            if(receiverTable.getSelectedReceiverGroups().size() == 1) {
                buDeactivateReceiver.setEnabled(receiverTable.getSelectedReceiverGroups().get(0).isActive());
                buActivateReceiver.setEnabled(!receiverTable.getSelectedReceiverGroups().get(0).isActive());
                miDeactivateReceiver.setEnabled(receiverTable.getSelectedReceiverGroups().get(0).isActive());
                miActivateReceiver.setEnabled(!receiverTable.getSelectedReceiverGroups().get(0).isActive());
            } else if (receiverTable.getSelectedReceiverGroups().size() > 1){
                buDeactivateReceiver.setEnabled(true);
                buActivateReceiver.setEnabled(true);
                miDeactivateReceiver.setEnabled(true);
                miActivateReceiver.setEnabled(true);
            } else {
                buDeactivateReceiver.setEnabled(false);
                buActivateReceiver.setEnabled(false);
                miDeactivateReceiver.setEnabled(false);
                miActivateReceiver.setEnabled(false);
            }

            // Show Button
            buShowReceiver.setEnabled(receiverTable.getSelectedReceivers().size() == 1);
            miShowReceiver.setEnabled(receiverTable.getSelectedReceivers().size() == 1);

            // Edit Button
            buEditReceiver.setEnabled(receiverTable.getSelectedReceiverGroups().size() == 1);
            miEditReceiver.setEnabled(receiverTable.getSelectedReceiverGroups().size() == 1);

            // Delete Button
            buDeleteReceiver.setEnabled(true);
            miDeleteReceiver.setEnabled(true);
        } else {
            buActivateReceiver.setEnabled(false);
            buDeactivateReceiver.setEnabled(false);
            buShowReceiver.setEnabled(false);
            buEditReceiver.setEnabled(false);
            buDeleteReceiver.setEnabled(false);

            miActivateReceiver.setEnabled(false);
            miDeactivateReceiver.setEnabled(false);
            miShowReceiver.setEnabled(false);
            miEditReceiver.setEnabled(false);
            miDeleteReceiver.setEnabled(false);
        }
    }



    /**
     * Notify the frame that the current profile has changed. Adjust the frame
     * title accordingly and enable or disable the "Save Profile" menu item
     */
    public void profileChanged(ProfileChangeEvent e) {
        setTitle(java.util.ResourceBundle.getBundle("internationalization/Bundle").getString("MainFrame.title") + ((view.getCurrentProfile() != null && view.getCurrentProfile().getName() != null) ? " - " + view.getCurrentProfile().getName() : ""));
        if(view.getCurrentProfile() != null) {
            miSaveProfile.setEnabled(true);
        } else {
            miSaveProfile.setEnabled(false);
        }
    }



    /**
     * Refresh the list of recent profiles in the File menu
     */
    private void loadRecentProfiles() {
        javax.swing.JMenuItem miRecentProfile;
        
        // get a list of profile items in menu. Also determine the position where
        // to insert the new items.
        List<JMenuItem> profileItems = new ArrayList<JMenuItem>();
        int insertPos = 0;
        boolean passedSeparator = false;
        for(int i=0; i< menuFile.getMenuComponentCount(); i++) {
            if(menuFile.getMenuComponent(i) == sepBeforeRecentProfiles) {
                passedSeparator = true;
                insertPos = i+1;
                continue;
            }
            if(menuFile.getMenuComponent(i) == sepAfterRecentProfiles) {
                break;
            }
            if(passedSeparator) {
                profileItems.add((JMenuItem)menuFile.getMenuComponent(i));
            }
        }
        
        // remove profile items from menu
        for(JMenuItem item : profileItems) {
            menuFile.remove(item);
        }

        // set insert position to end of menu as fallback solution
        if(insertPos == 0) {
            insertPos = menuFile.getMenuComponentCount();
        }

        // add the profiles
        for(Profile p : view.getRecentProfiles()) {
            miRecentProfile = new javax.swing.JMenuItem();
            miRecentProfile.setText(p.getName());
            miRecentProfile.setName("miRecentProfile" + p.getName());
            miRecentProfile.setActionCommand(p.getName());
            miRecentProfile.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    for(Profile p : view.getRecentProfiles()) {
                        if(p.getName().equals(evt.getActionCommand())) {
                            view.loadProfile(p.getPath());
                            return;
                        }
                    }
                }
            });
            menuFile.insert(miRecentProfile, insertPos++);
        }
    }



    /**
     * Notify the frame that overall receiver statistics have updated.
     */
    public void overallReceiverStatisticsUpdated(OverallReceiverStatisticsUpdatedEvent e) {
        ReceiverManager rm = e.getSource();
        laReceived.setText(Long.toString(rm.getOverallReceivedPackets()));
        laReceivingRate.setText(Long.toString(rm.getOverallReceivedPPS()));
        laLostPackets.setText(Long.toString(rm.getOverallLostPackets()));
        laFaultyPackets.setText(Long.toString(rm.getOverallFaultyPackets()));
    }



    /**
     * Notify the frame that overall sender statistics have updated.
     */
    public void overallSenderStatisticsUpdated(OverallSenderStatisticsUpdatedEvent e) {
        SenderManager sm = e.getSource();
        laSent.setText(Long.toString(sm.getOverallSentPackets()));
        laSenderRate.setText(Long.toString(sm.getOverallSentPPS()));
    }



    /**
     * Initialize all components not included in the <code>initComponents</code>
     * method. Those initializations are done here because <code>initComponents</code>
     * is auto-generated by netbeans and may not be edited.
     */
    private void initCustomComponents() {

        // create a central instance of file chooser to speed up its display
        chooser = new JFileChooser();

        // register the delete sender and receiver actions with the del key
        deleteReceiverAction = new DeleteReceiverAction();
        deleteSenderAction   = new DeleteSenderAction();
        senderTable.  getInputMap(WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0), "deleteSender");
        senderTable.  getActionMap().put("deleteSender", deleteSenderAction);
        receiverTable.getInputMap(WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0), "deleteReceiver");
        receiverTable.getActionMap().put("deleteReceiver", deleteReceiverAction);
    }



    /**
     * Action for deleting receivers. Needed for being able to do so via the
     * delete key.
     */
    private class DeleteReceiverAction extends AbstractAction {

        public DeleteReceiverAction() {
        }

        public void actionPerformed(ActionEvent e) {
            if(buDeleteReceiver.isEnabled()) {
                buDeleteReceiverActionPerformed(e);
            }
        }
    }



    /**
     * Action for deleting senders. Needed for being able to do so via the delete key.
     */
    private class DeleteSenderAction extends AbstractAction {

        public DeleteSenderAction() {
        }

        public void actionPerformed(ActionEvent e) {
            if(buDeleteSender.isEnabled()) {
                buDeleteSenderActionPerformed(e);
            }
        }
    }





}
